/**
 * POCDMT000040Material.java
 *
 * File generated from the cdaepsos3::POCDMT000040Material uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos4;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import net.ihe.gazelle.pharm.COCTMT230100UV01SpecializedKind;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040Material.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Material", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"code",
	"name",
	"desc",
	"formCode",
	"lotNumberText",
	"expirationTime",
	"asContent",
	"asSpecializedKind",
	"part",
	"ingredient",
	"classCode",
	"determinerCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.Material")
public class POCDMT000040Material implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "code", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE code;
	@XmlElement(name = "name", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.EN name;
	@XmlElement(name = "desc", namespace = "urn:hl7-org:pharm")
	public net.ihe.gazelle.datatypes.CE desc;
	@XmlElement(name = "formCode", namespace = "urn:hl7-org:pharm")
	public net.ihe.gazelle.datatypes.CE formCode;
	@XmlElement(name = "lotNumberText", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.ST lotNumberText;
	@XmlElement(name = "expirationTime", namespace = "urn:hl7-org:pharm")
	public net.ihe.gazelle.datatypes.IVLTS expirationTime;
	@XmlElement(name = "asContent", namespace = "urn:hl7-org:pharm")
	public net.ihe.gazelle.pharm.COCTMT230100UV01Content asContent;
	@XmlElement(name = "asSpecializedKind", namespace = "urn:hl7-org:pharm")
	public List<net.ihe.gazelle.pharm.COCTMT230100UV01SpecializedKind> asSpecializedKind;
	@XmlElement(name = "part", namespace = "urn:hl7-org:pharm")
	public List<net.ihe.gazelle.pharm.COCTMT230100UV01Part> part;
	@XmlElement(name = "ingredient", namespace = "urn:hl7-org:pharm")
	public List<net.ihe.gazelle.pharm.COCTMT230100UV01Ingredient> ingredient;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.EntityClassManufacturedMaterial classCode;
	@XmlAttribute(name = "determinerCode")
	public net.ihe.gazelle.voc.EntityDeterminerDetermined determinerCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;


	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}

	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}



	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}

	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}

	/**
	 * Return typeId.
	 * @return typeId
	 */
	public POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}

	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}




	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}

	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}



	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}

	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}





	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.datatypes.CE getCode() {
	    return code;
	}

	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.datatypes.CE code) {
	    this.code = code;
	}




	/**
	 * Return name.
	 * @return name
	 */
	public net.ihe.gazelle.datatypes.EN getName() {
	    return name;
	}

	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(net.ihe.gazelle.datatypes.EN name) {
	    this.name = name;
	}




	/**
	 * Return desc.
	 * @return desc
	 */
	public net.ihe.gazelle.datatypes.CD getDesc() {
	    return desc;
	}

	/**
	 * Set a value to attribute desc.
	 * @param desc.
	 */
	public void setDesc(net.ihe.gazelle.datatypes.CE desc) {
	    this.desc = desc;
	}



	/**
	 * Return formCode.
	 * @return formCode
	 */
	public net.ihe.gazelle.datatypes.CE getFormCode() {
	    return formCode;
	}

	/**
	 * Set a value to attribute formCode.
	 * @param formCode.
	 */
	public void setFormCode(net.ihe.gazelle.datatypes.CE formCode) {
	    this.formCode = formCode;
	}


	/**
	 * Return lotNumberText.
	 * @return lotNumberText
	 */
	public net.ihe.gazelle.datatypes.ST getLotNumberText() {
	    return lotNumberText;
	}

	/**
	 * Set a value to attribute lotNumberText.
	 * @param lotNumberText.
	 */
	public void setLotNumberText(net.ihe.gazelle.datatypes.ST lotNumberText) {
	    this.lotNumberText = lotNumberText;
	}



	/**
	 * Return expirationTime.
	 * @return expirationTime
	 */
	public net.ihe.gazelle.datatypes.IVLTS getExpirationTime() {
	    return expirationTime;
	}

	/**
	 * Set a value to attribute expirationTime.
	 * @param expirationTime.
	 */
	public void setExpirationTime(net.ihe.gazelle.datatypes.IVLTS expirationTime) {
	    this.expirationTime = expirationTime;
	}


	/**
	 * Return asContent.
	 * @return asContent
	 */
	public net.ihe.gazelle.pharm.COCTMT230100UV01Content getAsContent() {
	    return asContent;
	}

	/**
	 * Set a value to attribute asContent.
	 * @param asContent.
	 */
	public void setAsContent(net.ihe.gazelle.pharm.COCTMT230100UV01Content asContent) {
	    this.asContent = asContent;
	}




	/**
	 * Return asSpecializedKind.
	 * @return asSpecializedKind
	 */
	public List<net.ihe.gazelle.pharm.COCTMT230100UV01SpecializedKind> getAsSpecializedKind() {
		if (asSpecializedKind == null) {
	        asSpecializedKind = new ArrayList<COCTMT230100UV01SpecializedKind>();
	    }
	    return asSpecializedKind;
	}

	/**
	 * Set a value to attribute asSpecializedKind.
	 * @param asSpecializedKind.
	 */
	public void setAsSpecializedKind(List<net.ihe.gazelle.pharm.COCTMT230100UV01SpecializedKind> asSpecializedKind) {
	    this.asSpecializedKind = asSpecializedKind;
	}



	/**
	 * Add a asSpecializedKind to the asSpecializedKind collection.
	 * @param asSpecializedKind_elt Element to add.
	 */
	public void addAsSpecializedKind(net.ihe.gazelle.pharm.COCTMT230100UV01SpecializedKind asSpecializedKind_elt) {
	    this.getAsSpecializedKind().add(asSpecializedKind_elt);
	}

	/**
	 * Remove a asSpecializedKind to the asSpecializedKind collection.
	 * @param asSpecializedKind_elt Element to remove
	 */
	public void removeAsSpecializedKind(net.ihe.gazelle.pharm.COCTMT230100UV01SpecializedKind asSpecializedKind_elt) {
	    this.getAsSpecializedKind().remove(asSpecializedKind_elt);
	}

	/**
	 * Return part.
	 * @return part
	 */
	public List<net.ihe.gazelle.pharm.COCTMT230100UV01Part> getPart() {
		if (part == null) {
	        part = new ArrayList<net.ihe.gazelle.pharm.COCTMT230100UV01Part>();
	    }
	    return part;
	}

	/**
	 * Set a value to attribute part.
	 * @param part.
	 */
	public void setPart(List<net.ihe.gazelle.pharm.COCTMT230100UV01Part> part) {
	    this.part = part;
	}



	/**
	 * Add a part to the part collection.
	 * @param part_elt Element to add.
	 */
	public void addPart(net.ihe.gazelle.pharm.COCTMT230100UV01Part part_elt) {
	    this.getPart().add(part_elt);
	}

	/**
	 * Remove a part to the part collection.
	 * @param part_elt Element to remove
	 */
	public void removePart(net.ihe.gazelle.pharm.COCTMT230100UV01Part part_elt) {
	    this.getPart().remove(part_elt);
	}

	/**
	 * Return ingredient.
	 * @return ingredient
	 */
	public List<net.ihe.gazelle.pharm.COCTMT230100UV01Ingredient> getIngredient() {
		if (ingredient == null) {
	        ingredient = new ArrayList<net.ihe.gazelle.pharm.COCTMT230100UV01Ingredient>();
	    }
	    return ingredient;
	}

	/**
	 * Set a value to attribute ingredient.
	 * @param ingredient.
	 */
	public void setIngredient(List<net.ihe.gazelle.pharm.COCTMT230100UV01Ingredient> ingredient) {
	    this.ingredient = ingredient;
	}



	/**
	 * Add a ingredient to the ingredient collection.
	 * @param ingredient_elt Element to add.
	 */
	public void addIngredient(net.ihe.gazelle.pharm.COCTMT230100UV01Ingredient ingredient_elt) {
	    this.getIngredient().add(ingredient_elt);
	}

	/**
	 * Remove a ingredient to the ingredient collection.
	 * @param ingredient_elt Element to remove
	 */
	public void removeIngredient(net.ihe.gazelle.pharm.COCTMT230100UV01Ingredient ingredient_elt) {
	    this.getIngredient().remove(ingredient_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.EntityClassManufacturedMaterial getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.EntityClassManufacturedMaterial classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return determinerCode.
	 * @return determinerCode
	 */
	public net.ihe.gazelle.voc.EntityDeterminerDetermined getDeterminerCode() {
	    return determinerCode;
	}
	
	/**
	 * Set a value to attribute determinerCode.
	 * @param determinerCode.
	 */
	public void setDeterminerCode(net.ihe.gazelle.voc.EntityDeterminerDetermined determinerCode) {
	    this.determinerCode = determinerCode;
	}




	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}

	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}





	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos4");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Material").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}

	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}





	/**
     * validate by a module of validation
     *
     */
   public static void validateByModule(POCDMT000040Material pOCDMT000040Material, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Material != null){
   			cvm.validate(pOCDMT000040Material, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040Material.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Material.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040Material.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Material.getCode(), _location + "/code", cvm, diagnostic);
			net.ihe.gazelle.datatypes.EN.validateByModule(pOCDMT000040Material.getName(), _location + "/name", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CD.validateByModule(pOCDMT000040Material.getDesc(), _location + "/desc", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CD.validateByModule(pOCDMT000040Material.getFormCode(), _location + "/formCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.ST.validateByModule(pOCDMT000040Material.getLotNumberText(), _location + "/lotNumberText", cvm, diagnostic);
			net.ihe.gazelle.datatypes.IVLTS.validateByModule(pOCDMT000040Material.getExpirationTime(), _location + "/expirationTime", cvm, diagnostic);

			net.ihe.gazelle.pharm.COCTMT230100UV01Content.validateByModule(pOCDMT000040Material.getAsContent(), _location + "/asContent", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.pharm.COCTMT230100UV01SpecializedKind asSpecializedKind: pOCDMT000040Material.getAsSpecializedKind()){
					net.ihe.gazelle.pharm.COCTMT230100UV01SpecializedKind.validateByModule(asSpecializedKind, _location + "/asSpecializedKind[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.pharm.COCTMT230100UV01Part part: pOCDMT000040Material.getPart()){
					net.ihe.gazelle.pharm.COCTMT230100UV01Part.validateByModule(part, _location + "/part[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.pharm.COCTMT230100UV01Ingredient ingredient: pOCDMT000040Material.getIngredient()){
					net.ihe.gazelle.pharm.COCTMT230100UV01Ingredient.validateByModule(ingredient, _location + "/ingredient[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

    	}
    }

}